package fxVuororekisteri;


import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.util.Pair;
import vuororekisteri.Laji;
import vuororekisteri.Vuororekisteri;


/**
 * @author Elias Haverinen, Lauri Vepsäläinen
 * @version 4.4.2025
 * Lajin lisäys ikkunan kontrolleri
 * Hoitaa muun muassa lajin oikeellisuustarkastukset ja lajin luomiseen liittyvän käsittelyn
 */
public class LajinLisaysGUIController implements ModalControllerInterface<Pair<Laji, Vuororekisteri>> {


    @FXML
    private Button buttonPeruuta;

    @FXML
    private Button buttonTallenna;

    @FXML
    private TextField textLaji;

    @FXML
    private TextField textSijainti;

    @FXML
    private TextField textTaso;

    @FXML
    void handlePeruuta() {
        peruuta();
    }

    @FXML
    void handleTallenna() {
        tallenna();
    }

    @FXML
    void handleTarkista() {
         //
    }

    // ================================================================================================================================

    private final Laji laji = new Laji();
    private Vuororekisteri vuororekisteri;

    private void peruuta() {

        ModalController.closeStage(buttonPeruuta);
    }


    /**
     * tarkistaa lajin luomisen yhteydessä että lajia jota halutaan luoda ei ole jo olemassa
     * @return palauttaa true jos laji on ainutlaatuinen, false jos kyseinen laji on jo olemassa
     */
    public boolean tarkistaLaji() {

        for (int i = 0; i<vuororekisteri.getLajeja(); i++) {
            Laji laji1 = vuororekisteri.annaLaji(i);
            if (laji1.getNimi().equals(textLaji.getText()) && laji1.getSijainti().equals(textSijainti.getText()) && laji1.getTaso().equals(textTaso.getText())) {
                return false;
            }
        }
        return true;
    }


    /**
     * Laji rekisteröidään eli se saa id:n
     * lajille asetetaan arvot syötteestä tai jos syöte ei täytä kriteerejä niin vuorolle laitetaan "leikki" arvot
     */
    public void tallenna() {

        if (tarkistaLaji()) {
            laji.rekisteroi();

            if (textLaji.getText().isEmpty() || textSijainti.getText().isEmpty() || textTaso.getText().isEmpty()) {
                laji.asetaTesti();
            } else laji.asetaTesti(textLaji.getText(), textSijainti.getText(), textTaso.getText());
        }

        else {
            Dialogs.showMessageDialog("Tämä laji on jo olemassa");
        }

        ModalController.closeStage(buttonTallenna);
    }


    /**
     * Palauttaa luodun lajin parissa jos sellainen on onnistunut
     * @return pari jossa luotu laji
     */
    @Override
    public Pair<Laji, Vuororekisteri> getResult() {
        return new Pair<>(laji, null);
    }

    /**
     * Asetetaan tuodun parin mukana tullut vuororekisteri myös tämän ikkunan tuntemaksi käsittelyä varten
     * @param tuonti pari jossa vuororekisteri
     */
    @Override
    public void setDefault(Pair<Laji, Vuororekisteri> tuonti) {
        this.vuororekisteri = tuonti.getValue();
    }


    @Override
    public void handleShown() {

    }

}
