package fxVuororekisteri;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.util.Pair;
import vuororekisteri.Vuororekisteri;

/**
 * @author Elias Haverinen, Lauri Vepsäläinen
 * @version 4.4.2025
 * Vuoronvarausikkunan controller luakka
 * Hoitaa muun muassa nimen tarkistuksen
 */
public class VuoronVarausGUIController implements ModalControllerInterface<Pair<Integer, Vuororekisteri>> {


    @FXML
    private Button buttonVuoronVaraus;

    @FXML
    private TextField textVuoronVarausNimi;

    @FXML
    private TextField textVuronVarausNRO;


    @FXML
    void handleVuoronVarausTarkistaNimi() {
        //tarkistus(textVuoronVarausNimi);
    }

    @FXML
    void handleVuoronVarausTarkistaNRO() {
        //tarkistus(textVuronVarausNRO);
    }


    @FXML
    void handleVuoronVaraus() {
        varaus();
    }

    /// ==========================================================================================================================

    private Vuororekisteri vuororekisteri;
    private int vuoronID;


    /**
     * tarkistuksen mentyä läpi, varataan vuoro, eli muutetaan sen status varatuksi/false
     */
    public void varaus() {

        if (tarkistus()) {
            for (int i = 0; i < vuororekisteri.getVuoroja(); i++) {
                if (vuororekisteri.annaVuoro(i).getVuoroID() == vuoronID) {

                    vuororekisteri.annaVuoro(i).varaaVuoro();
                    ModalController.closeStage(buttonVuoronVaraus);
                    return;
                }
            }
        }
        else {
            Dialogs.showMessageDialog("Tarkista kentät");
        }
        ModalController.closeStage(buttonVuoronVaraus);
    }


    /**
     * tarkistetaan että vuoron varauksen yhteydessä kirjoitetut varaajan tiedot ovat oikeudenmukaisia
     * @return true jos tiedot on annettu oikein, false jos tiedot on älyttömät
     */
    public boolean tarkistus() {
        boolean tarkistus = true;

        if (textVuronVarausNRO.getText().isEmpty()) return false;
        if (textVuoronVarausNimi.getText().isEmpty()) return false;
        if (textVuronVarausNRO.getText().matches(".*[a-zA-ZåäöÅÄÖ].*")) {
            return false;
        }
        if (textVuoronVarausNimi.getText().matches(".*[0-9].*")) {
            return false;
        }
        if ( textVuronVarausNRO.getText().length() > 11 || textVuronVarausNRO.getText().length() < 5) {
            return false;
        }
        return tarkistus;
    }

    /**
     * täältä palautetaa pari jossa ei ole mitään, koska ei tarvitse
     * @return parin joka null
     */
    @Override
    public Pair<Integer, Vuororekisteri> getResult() {
        return new Pair<>(null, null);
    }

    /**
     * Tuodut parametrit eli varattavan vuoron id ja vuororekisteri asetetaan myös tämän ikkunan tuntemiksi, jotta niitä pystytään käsittelemään myöhemmin
     * @param tuonti Pari jossa varattavan vuoron id sekä vuororekisteri
     */
    @Override
    public void setDefault(Pair<Integer, Vuororekisteri> tuonti) {
        this.vuoronID = tuonti.getKey();
        this.vuororekisteri = tuonti.getValue();
    }


    @Override
    public void handleShown() {

    }

}
