package fxVuororekisteri;

import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.fxml.FXMLLoader;
import vuororekisteri.Vuororekisteri;


/**
 * @author Elias Haverinen, Lauri Vepsäläinen
 * @version 4.4.2025
 * Vuororekisterin pääohjelma josta koko systeemi käynnistyy
 */
public class VuororekisteriMain extends Application {
    @Override
    public void start(Stage primaryStage) {
        try {
            FXMLLoader ldr = new FXMLLoader(getClass().getResource("VuororekisteriGUIView.fxml"));
            final Pane root = ldr.load();
            final VuororekisteriGUIController vuororekisteriCtrl = (VuororekisteriGUIController)ldr.getController();
            Scene scene = new Scene(root);
            scene.getStylesheets().add(getClass().getResource("vuororekisteri.css").toExternalForm());
            primaryStage.setScene(scene);
            primaryStage.setTitle("Vuororekisteri");
            Vuororekisteri vuororekisteri = new Vuororekisteri();
            vuororekisteriCtrl.setVuororekisteri(vuororekisteri);
            primaryStage.show();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * @param args Ei käytössä
     */
    public static void main(String[] args) {
        launch(args);
    }
}